$STORAGE :2
      PROGRAM LEX2WS2
C**      DEE BEOUGHER,  START DATE: JAN. 20, 1988
C**                     MODIFIED  : JAN. 20, 1989
C*
C*   ASCII FILES HAVE A CARRIAGE RETURN, LINE FEED AT THE END OF EACH
C*   LINE AND TWO SETS AT THE END OF A PARAGRAPH.  WORDSTAR 2000 REL. 2
C*   USES HEX '7F 03 7F' FOR A SOFT CARRIAGE RETURN WITHIN A 
C*   PARAGRAPH AND '0A 0A' AT THE END OF A PARAGRAPH.
C*   '0D 0A 0D 0A' WORKS ALRIGHT FOR THE END OF A PARAGRAPH.
C*   THIS PROGRAM REPLACES THE HARD CARRIAGE RETURN WITH
C*   THE SOFT CARRIAGE RETURN EXCEPT AT THE END OF A PARAGRAPH.
C*   IT ALSO REMOVES BLANK SPACES AT THE BEGINNING OF LINES.
C*   THE LEXITRON DEGREE COMMUNICATES TO THE PC AS A GRAVE ACCENT (`),
C*   WHICH IS REPLACED BY THIS PROGRAM WITH A SUPERSCRIPT SMALL O.
C*   BLANK LINES AT THE END OF FILE ARE ELIMINATED AND BLANK SPACES AT
C*   BEGINNING OF LINES ARE NOT SAVED.
C*
C*   THE SECOND PART OF THE PROGRAM CONVERTS UNDERSCORES (FROM
C*   THE LEXITRON FILE) TO WORDSTAR'S TOGGLE ON/OFF.  THREE
C*   OR MORE UNDERSCORES ARE RECOGNIZED AS A LINE AND ARE
C*   NOT CHANGED.
C*
C*   A PARAGRAPH IS SINGLE SPACED AND A BLANK LINE SEPARATES 
C*   PARAGRAPHS.  USER WILL BE ASKED TO NAME AN INPUT FILE AND
C*   AN OUTPUT FILE. 
C*
C*   ONE INTERMEDIATE FILE (CONV.TMP) IS CREATED AND DELETED.
C*
C*     VARIABLES
C*
C*      LINE        ARRAY TO HOLD 512 BYTES OF THE TEXT
C*      LIMIT       ARRAY MAXIMUM
C*      IFLAG       FLAG SET 1 WHEN END OF PARAGRAPH SEQUENCE IS
C*                   FOUND TO KEEP SECOND '0D' FROM BEING CHANGED
C*      NEXT        ARRAY TO READ NEXT CHARACTERS
C*      I, KK, LL   INDEX
C*      CURPOS           INDEX -- CURRENT POSITION IN LINE ARRAY
C*      BEGPOS                    BEGINNING OF LINE POSITION
C*      ENDPOS                    MAXIMUM ARRAY POSITION
C*      IDELETE     FLAG TO INDICATE NEXT BLANK GETS DELETED
C*                    IDELETE = 1, CHECK FIRST POSITION
C*                    IDELETE = 2, CHECK SECOND POSITION
C*      KEND        LAST PRINTABLE CHARACTER - FOUND BY SUBROUTINE
C*                      FINDEND
C*      KOUNT       RUNNING COUNT OF CHARACTERS READ
C*      KPCT        PERCENT OF FILE PROCESSED
C*      KLFERR      COUNT LINE FEED ERRORS
C*      LFERR       LOGICAL SET TRUE IF LF ERRORS EXISTS
C*      EOF         END OF FILE
C*      EOLN        END OF LINE
C*      SPACE       CHECK FOR MORE SPACES
C*      SKIPWRIT    SKIP THE WRITE STATEMENT
C*      SERIES      LOGICAL SERIES OF UNDERSCORES (A LINE)
C*
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      INTEGER*4 KOUNT,KEND,KPCT
      CHARACTER*32 UNIT21,UNIT22,UNIT24
      LOGICAL EOF,EOLN,SPACE,SKIPWRIT,LFERR,UNSCR,TOGGLEON,SUBSPACE
      LOGICAL DEG,SOFTRT,SERIES,FILERR
      CHARACTER*1 LINE(512)
      CHARACTER*1 NEXT(5)
      CHARACTER*1 CH,POS1,POS2,POS3,POS5
      PARAMETER (LIMIT = 512)
C*
5     WRITE(*,10)
10    FORMAT (' ',/, ' NAME THE INPUT FILE : '\)
      READ (*,'(A)')UNIT21
      CALL CKSAFE(UNIT21,2,FILERR)
      IF (FILERR) GO TO 5
C*
      UNIT22 = 'CONV.TMP'
15    CALL CKSAFE(UNIT22,1,FILERR)
      IF (FILERR) THEN
        WRITE(*,20)
20      FORMAT(' ','NAME THE INTERMEDIATE FILE: '\)
        READ(*,'(A)')UNIT22
        GOTO 15
      ENDIF
C*
35    WRITE(*,50)
50    FORMAT(' ','NAME THE OUTPUT FILE: '\)
      READ(*,'(A)')UNIT24
      CALL CKSAFE(UNIT24,1,FILERR)
      IF (FILERR) GO TO 35
C*
      OPEN(21,FILE=UNIT21,STATUS='OLD',FORM='BINARY')
      OPEN(22,FILE=UNIT22,STATUS='UNKNOWN',FORM='BINARY')
      OPEN(24,FILE=UNIT24,STATUS='UNKNOWN',FORM='BINARY')
C*
      IFILE = 21
      WRITE(*,'('' ''/,'' THERE ARE TWO PARTS TO THE PROCESS''/)')
C*
C*    CALL SUBROUTINE FINDEND TO FIND THE LAST DATA CHARACTER.
C*
      CALL FINDEND(KEND,EOF,IFILE)
C*
C*  
C*    INITIALIZING EOLN TO TRUE CAUSES THE BEGINNING OF THE
C*      FILE TO BE SCANNED FOR BLANKS.
C*
      KOUNT = 0
      IFLAG = 0
      EOF = .FALSE.
      EOLN = .TRUE.
      SPACE = .FALSE.
      SKIPWRIT = .FALSE.
      LFERR = .FALSE.
      KLFERR = 0
      DEG = .FALSE.
      SOFTRT = .FALSE.
      SERIES = .FALSE.
      REWIND IFILE
C*
      CALL CONV1(ENDPOS,BEGPOS,KOUNT,LINE,LIMIT,KEND,CURPOS,SKIPWRIT,
     :           IDELETE, EOLN, SPACE,NEXT,IFLAG,LFERR,KLFERR,POS2,
     :           POS3,IFILE,DEG,SOFTRT)
C*
      IFILE = 22
      REWIND IFILE
      WRITE(*,'('' '',/'' BEGIN SECOND PHASE''/)')
C*
C*    CALL SUBROUTINE FINDEND TO FIND THE LAST DATA CHARACTER.
C*
      CALL FINDEND(KEND,EOF,IFILE)
C*
      KOUNT = 0
      TOGGLEON = .FALSE.
      SUBSPACE = .FALSE.
      UNSCR = .FALSE.
      SKIPWRIT = .FALSE.
      REWIND IFILE
C*
      CALL CONV2(ENDPOS,BEGPOS,KOUNT,LINE,KEND,CURPOS,TOGGLEON,
     :          SKIPWRIT,NEXT,SUBSPACE,UNSCR,IFILE,LIMIT,SERIES)
C*
C*
      IF (UNSCR) THEN 
        WRITE(*,'(/,'' '','' UNDERSCORES CONVERTED'')')
      ELSE
        WRITE(*,'(/,'' '',''NO UNDERSCORES LOCATED IN FILE'')')
      ENDIF
      IF (DEG) THEN
        WRITE(*,'('' '','' DEGREE CONVERTED'')')
      ELSE
        WRITE(*,'('' '','' NO DEGREE SYMBOL LOCATED'')')
      ENDIF
c**    ADD END OF FILE CHARACTERS
      WRITE(24) CHAR(#0D)
      WRITE(24) CHAR(#0A)
      WRITE(24) CHAR(#0D)
      WRITE(24) CHAR(#0A)
      WRITE(24) CHAR(#1A)
      CLOSE(21)
      CLOSE(22,STATUS='DELETE')
      CLOSE(24)
      IF (LFERR) THEN
        WRITE(*,110)KLFERR
110     FORMAT(/,' LINE FEED ERROR COUNT = ',I6)
      ENDIF
      STOP 'END OF PROGRAM'
      END
C*
C*    END OF MAIN PROGRAM
C*********************************************************************
C*
      SUBROUTINE FINDEND(KFIRST,EOF,IFILE)
C*
C*   THIS SUBROUTINE READS TO "END OF FILE" CHARACTER (HEX 1A), THEN
C*   BACKS UP TO THE LAST PRINTABLE CHARACTER AND SAVES THIS
C*   COUNT POSITION TO BE THE LAST CHARACTER WRITTEN TO THE NEW
C*   FILE.
C*
      INTEGER*4 KFIRST,K
      CHARACTER*1 CH
      LOGICAL EOF
C*
75    K = 0
      KBACK = 0
C*
      WRITE (*,'(''+'',''FINDING LAST PRINTABLE CHARACTER ''\)')
80    K=K+1
      READ (IFILE,END = 900) CH
      IF (CH .EQ. CHAR(#1A)) GOTO 900
      GO TO 80
900   EOF=.TRUE.
C*
      K = K-1
C*
      BACKSPACE IFILE
      BACKSPACE IFILE
      READ(IFILE)CH
      KBACK = KBACK +1
83    IF (CH .EQ. CHAR(#0D) .OR. CH .EQ. CHAR(#0A) 
     :  .OR. CH .EQ. CHAR(#20) .OR. CH .EQ. CHAR(#8D)) THEN
      BACKSPACE IFILE
      BACKSPACE IFILE
      READ(IFILE)CH
      KBACK = KBACK+1
      GOTO 83
      ENDIF
      KBACK = KBACK -1
      KFIRST = K - KBACK
      WRITE (*,94)KFIRST
94    FORMAT(' ',': ',I8)
      WRITE(*,60)
60    FORMAT(' ',/)
      END
C*
C*     END OF SUBROUTINE FINDEND
C**********************************************************************
C*
      SUBROUTINE CONV1(ENDPOS,BEGPOS,KOUNT,LINE,LIMIT,KEND,CURPOS,
     :           SKIPWRIT,IDELETE,EOLN,SPACE,NEXT,IFLAG,LFERR,KLFERR,
     :           POS2,POS3,IFILE,DEG,SOFTRT)
C*
C*   PROCESSING LOOP FIRST PHASE: CONVERTS DEGREE SYMBOL, AND
C*    SOFT CARRIAGE RETURN AND ELIMINATES BLANK SPACES.
C*
      INTEGER*4 KOUNT,KEND,KPCT
      INTEGER CURPOS,BEGPOS,ENDPOS
      LOGICAL EOLN,SPACE,SKIPWRIT,LFERR,DEG,SOFTRT
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
      CHARACTER*1 POS2,POS3
75    ENDPOS = 0
      BEGPOS = 1
C*
      WRITE (*,'(''+'',''PROCESSING DATA FIRST PHASE ''\)')
80    ENDPOS=ENDPOS+1
      KOUNT = KOUNT+1
      READ (IFILE) LINE(ENDPOS)
      IF(ENDPOS.EQ.LIMIT) GO TO 85
      IF(KOUNT .EQ. KEND) GOTO 85
      GO TO 80
C*
C**   CHECK DATA
C* 
85    DO 95 CURPOS = 1,ENDPOS
      IF (LINE(CURPOS) .EQ. CHAR(#60)) THEN
        CALL CVTDEGRE(LINE, CURPOS, BEGPOS, SKIPWRIT,ENDPOS,DEG)
      ENDIF
      IF (IDELETE .EQ. 1 .OR. IDELETE .EQ. 2) THEN
        CALL DELSPACE(IDELETE, BEGPOS, CURPOS, LINE,ENDPOS,SKIPWRIT)
      ENDIF
      IF (EOLN) THEN
        CALL ENDOFLI(LINE,BEGPOS,CURPOS,EOLN,SPACE,ENDPOS,SKIPWRIT)
      ENDIF
      IF (LINE(CURPOS) .EQ. CHAR(#0A) .AND. SOFTRT) THEN
        CALL SOFT2(SOFTRT,LINE,BEGPOS,CURPOS,SKIPWRIT,ENDPOS)
      ENDIF
      IF (LINE(CURPOS) .EQ. CHAR(#0D)) THEN
        CALL CHECKDATA  (LINE, NEXT, CURPOS, IDELETE, EOLN, IFLAG,
     :    LIMIT, LFERR, KLFERR, KEND, KOUNT, POS2, POS3,IFILE,SOFTRT)
      ENDIF
95    CONTINUE
C*
C**  WRITE THE LINE -- SKIPWRIT (BOOLEAN VARIABLE) IS FALSE
C*      UNLESS CHANGED TO SKIP THE WRITE STATEMENT.
C*
      IF (.NOT. SKIPWRIT) THEN
        WRITE(22)(LINE(I), I=BEGPOS,ENDPOS)
      ELSE
        SKIPWRIT = .FALSE.
      ENDIF
      KPCT = KOUNT*100/KEND
      WRITE(*,97)KPCT
97    FORMAT(' ',': ',I4,' PERCENT COMPLETE')
      IF(KOUNT .LT. KEND) GO TO 75
C*
c**    ADD END OF FILE CHARACTERS
      WRITE(22) CHAR(#1A)
C*
      END
C*    END OF SUBROUTINE CONV1
C*
C**********************************************************************
C*
      SUBROUTINE CONV2(ENDPOS,BEGPOS,KOUNT,LINE,KEND,CURPOS,
     : TOGGLEON,SKIPWRIT,NEXT,SUBSPACE,UNSCR,IFILE,LIMIT,SERIES)
C*
C*   PROCESSING LOOP SECOND PHASE: CONVERTS UNDERSCORES.  THREE
C*   OR MORE UNDERSCORES ARE RECOGNIZED AS A LINE AND ARE NOT 
C*   CHANGED.
C*
      INTEGER*4 KOUNT,KEND,KPCT
      INTEGER CURPOS,BEGPOS,ENDPOS
      LOGICAL TOGGLEON,SKIPWRIT,SUBSPACE,UNSCR,SERIES
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
C*
175   ENDPOS = 0
      BEGPOS = 1
C*
      WRITE (*,'(''+'',''PROCESSING DATA SECOND PHASE''\)')
180   ENDPOS=ENDPOS+1
      KOUNT = KOUNT+1
      READ (IFILE) LINE(ENDPOS)
      IF(ENDPOS.EQ.LIMIT)GO TO 185
      IF(KOUNT .EQ. KEND) GOTO 185
      GO TO 180
C*
C**   CHECK DATA:  UNDERSCORE CONVERSION.
C* 
185   DO 195 CURPOS = 1,ENDPOS
      IF (SERIES .AND. LINE(CURPOS) .NE. CHAR(#5F)) SERIES = .FALSE.
      IF (TOGGLEON .AND. LINE(CURPOS) .NE. CHAR(#5F)) THEN
        IF (LINE(CURPOS) .NE. CHAR(#0D)) THEN
            IF (LINE(CURPOS) .NE. CHAR(#7F)) THEN
              IF (LINE(CURPOS) .NE. CHAR(#0A)) THEN
              IF (LINE(CURPOS) .NE. CHAR(#03)) THEN
              IF (LINE(CURPOS) .NE. CHAR(#20)) THEN
              CALL UNTOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE,
     :                     LIMIT,NEXT,KEND, KOUNT,IFILE)
              ENDIF
              ENDIF
              ENDIF
            ENDIF
        ENDIF
      ELSEIF (LINE(CURPOS) .EQ. CHAR(#5F)) then
        IF (.NOT. TOGGLEON) THEN
          IF (.NOT. SERIES) THEN
            CALL SERSCK(LINE,SERIES,KEND,KOUNT,IFILE,NEXT,CURPOS,
     :            LIMIT)
          ENDIF
        ENDIF
        IF (.NOT. SERIES) THEN
          CALL UNDSCORE(LINE,TOGGLEON,BEGPOS,CURPOS,ENDPOS,SUBSPACE,
     :     NEXT,SKIPWRIT, KEND, KOUNT,UNSCR,LIMIT,IFILE)
        ENDIF
      ENDIF
C*
195   CONTINUE
C*
C**  WRITE THE LINE
C*
      IF (.NOT. SKIPWRIT) THEN
        WRITE(24)(LINE(I), I=BEGPOS,ENDPOS)
      ELSE
        SKIPWRIT = .FALSE.
      ENDIF
      KPCT = KOUNT*100/KEND
      WRITE (*,97)KPCT
97    FORMAT(' ',': ',I4,' PERCENT COMPLETE')
      IF(KOUNT .LT. KEND) GO TO 175
C*
      END
C*    END OF SUBROUTINE CONV2
C**********************************************************************
C*
      SUBROUTINE CHECKDATA (LINE, NEXT, CURPOS, IDELETE, EOLN, IFLAG,
     :  LIMIT, LFERR, KLFERR, KEND, KOUNT, POS2, POS3,IFILE,SOFTRT)
C*    
C*    THIS SUBROUTINE CHECKS TO SEE IF THE CARRIAGE CONTROL 
C*     CHARACTER, 0D, SHOULD BE REPLACED WITH A SOFT CARRIAGE
C*     RETURN.  WHEN THERE IS A SEQUENCE, (0D 0A 0D 0A) 
C*     OR (0D 0A 20 0D 0A) THEN
C*     THE 0D SHOULD NOT BE CHANGED. IF JUST '0D 0A' APPEARS, IT SHOULD 
C*     BE CHANGED.  THE PROGRAM LOOKS AT THE SECOND AND THIRD 
C*     CHARACTER FOLLOWING TO KNOW IF THIS CONDITION EXISTS.  A FLAG IS
C*     SET TO 1 WHICH CAUSES THE SECOND '0D' IN THE SEQUENCE NOT TO BE
C*     CHANGED.  IDELETE IS SET TO 1 FOR THE DELSPACE SUBROUTINE.
C*     THE PROGRAM READS 512 BYTES.  IF THE '0D' IS FOUND
C*     NEAR THE END OF THIS SET OF DATA, THREE MORE CHARACTERS ARE READ
C*     AND CHECKED, THEN THE POINTER IS SET BACK THREE SPACES SO THEY
C*     ARE READ IN THE NEXT 512 BYTES.
C*
C*     ALSO LOOK FOR "LINE FEED" PRECEEDING THE "CARRIAGE RETURN"
C*       AND CALL SUBROUTINE LF_ERROR.
C*
C*     EOLN (END OF LINE) IS FOUND FOR DELETING SPACES IN THE 
C*     SUBROUTINE ENDOFLI.
C*
      INTEGER*4 KEND,KOUNT
      INTEGER CURPOS
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
      CHARACTER*1 POS2,POS3
      LOGICAL EOLN,LFERR,SOFTRT
C*
C*
      IF (IFLAG .EQ. 0) THEN
C*      (COMMENT:  LOOK FOR WRONG SEQUENCE: 0A 0D)
        IF (CURPOS .GT. 2 ) THEN
          IF (LINE(CURPOS-1) .EQ. CHAR(#0A)) THEN
            IF (LINE(CURPOS-2) .NE. CHAR(#0D)) THEN
              CALL LF_ERROR(LFERR,KLFERR)
            ENDIF
          ENDIF
        ENDIF
        IF (CURPOS .LE. LIMIT-3) THEN
         POS2 = LINE(CURPOS+2)
         POS3 = LINE(CURPOS+3)
         CALL CRCHECK(LINE,EOLN,CURPOS,IFLAG,IDELETE,POS2,POS3,
     :   SOFTRT)
        ELSEIF (KEND-KOUNT .GE. 3) THEN
C*        THE "IF" STATEMENT IS FALSE -- CURPOS IS GREATER THAN 509.
C*        THERE ARE AT LEAST THREE CHARACTERS LEFT IN THE FILE.
C*  
          READ(IFILE) (NEXT(KK), KK = 1,3)
          IF (CURPOS .EQ. LIMIT-2) THEN
            POS2 = LINE(CURPOS+2)
            POS3 = NEXT(1)
            CALL CRCHECK(LINE,EOLN,CURPOS,IFLAG,IDELETE,POS2,POS3,
     :       SOFTRT)
          ENDIF
          IF (CURPOS .EQ. LIMIT-1) THEN
            POS2 = NEXT(1)
            POS3 = NEXT(2)
            CALL CRCHECK(LINE,EOLN,CURPOS,IFLAG,IDELETE,POS2,POS3,
     :        SOFTRT)
          ENDIF
          IF (CURPOS .EQ. LIMIT) THEN
           POS2 = NEXT(2)
           POS3 = NEXT(3)
           CALL CRCHECK(LINE,EOLN,CURPOS,IFLAG,IDELETE,POS2,POS3,
     :       SOFTRT)
          ENDIF
C*
          CALL BACKSP(KK,IFILE)
C*         (COMMENT: END OF ELSEIF BLOCK)
        ELSE
C*        COMMENT: ASSUME IT'S NOT END OF PARAGRAPH
          CALL SOFTCR(LINE,EOLN,CURPOS,SOFTRT)
        ENDIF
      ELSE
        IFLAG = 0
        EOLN = .TRUE.
      ENDIF
C*
      END
C*

C*    END OF SUBROUTINE CHECKDATA
C********************************************************************
C*
      SUBROUTINE CRCHECK(LINE,EOLN,CURPOS,IFLAG,IDELETE,POS2,POS3,
     :    SOFTRT)
C*
C*    THIS SUBROUTINE CHECKS FOR ANOTHER CARRIAGE CONTROL CHARACTER
C*    TO DETERMINE IF IT SHOULD BE A SOFT OR HARD CARRIAGE CONTROL.
C*
      INTEGER CURPOS
      CHARACTER*1 LINE(*)
      CHARACTER*1 POS2,POS3
      LOGICAL EOLN,SOFTRT
C*
          IF (POS2 .NE. CHAR(#0D) .AND. POS3 .NE. CHAR(#0D))
     :       THEN
            CALL SOFTCR(LINE,EOLN,CURPOS,SOFTRT)
          ENDIF
          IF (POS2 .EQ. CHAR(#0D) .OR. POS3 .EQ. CHAR(#0D))
     :     THEN
           CALL NOSOFTCR(IFLAG,IDELETE)
          ENDIF
      END
C*    END OF SUBROUTINE CRCHECK
C*********************************************************************
      SUBROUTINE BACKSP(KK,IFILE)
C*
C*        MOVE POINTER IN FILE BACK 
C*
          KK  = KK -1
          DO 199 LL = 1,KK
            BACKSPACE IFILE
199       CONTINUE
      END
C*    END OF SUBROUTINE BACKSP
C*********************************************************************
      SUBROUTINE SOFTCR(LINE,EOLN,CURPOS,SOFTRT)
C*
C*    THIS SUBROUTINE REPLACES THE CARRIAGE RETURN WITH SOFT RETURN
C*
      INTEGER CURPOS
      CHARACTER*1 LINE(*)
      LOGICAL EOLN,SOFTRT
C*
       LINE(CURPOS) = CHAR(#20)
       EOLN = .TRUE.
       SOFTRT = .TRUE.
C*
      END
C*    END OF SUBROUTINE SOFTCR
C*********************************************************************
C*
      SUBROUTINE SOFT2(SOFTRT,LINE,BEGPOS,CURPOS,SKIPWRIT,ENDPOS)
C*
C*    THIS SUBROUTINE SUPPLIES THE REST OF THE CHARACTERS OF 
C*    THE SOFT CARRIAGE RETURN AND ELIMINATES THE HEX '0A'.
C*
      INTEGER CURPOS, BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      LOGICAL SOFTRT,SKIPWRIT
C*
      LINE(CURPOS) = CHAR(#7F)
      WRITE(22) (LINE(I),I=BEGPOS,CURPOS)
      WRITE(22) CHAR(#03)
      WRITE(22) CHAR(#7F)
      CALL SKIPCP(CURPOS,ENDPOS,BEGPOS,SKIPWRIT)
      SOFTRT = .FALSE.
      END
C*    END OF SOFT2
C*********************************************************************
C*
      SUBROUTINE NOSOFTCR(IFLAG,IDELETE)
C*
C*       THIS SUBROUTINE SETS FLAG VALUES FOR NO SOFT CARRIAGE RETURN.
C*
       IFLAG = 1
       IDELETE = 1
      END
C*    END OF NOSOFTCR
C*********************************************************************
      SUBROUTINE LF_ERROR(LFERR,KLFERR)
C*
C**   THIS SUBROUTINE WRITES A MESSAGE ABOUT THE LINE FEED ERROR.
C*
      CHARACTER *1 STOPPROG
      LOGICAL LFERR
C*
      IF (.NOT. LFERR) THEN
       WRITE (*,60)
60     FORMAT(' ',/)
        WRITE (*,'('' '',''*************************************** '')')
        WRITE (*,'('' '',''THIS FILE HAS THE LINE FEED BEFORE THE '')')
        WRITE (*,'('' '',''CARRIAGE RETURN.  THE PROGRAM MIGHT NOT '')')
        WRITE (*,'('' '',''CORRECTLY CONVERT THE FILE FOR WORDSTAR.'')')
        WRITE (*,'('' '',''*************************************** '')')
        WRITE (*,'('' '','' '')')
      ENDIF
      KLFERR = KLFERR + 1
      LFERR = .TRUE.
      END
C*
C*       END OF SUBROUTINE LF_ERROR
C**********************************************************************
      SUBROUTINE DELSPACE(IDELETE,BEGPOS,CURPOS,LINE,ENDPOS,SKIPWRIT)
C*
C*    THIS SUBROUTINE LOOKS AT THE TWO POSITIONS FOLLOWING
C*    A CARRIAGE RETURN TO DETERMINE IF THEY ARE SPACES TO
C*    BE DELETED.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      LOGICAL SKIPWRIT
c*
      IF (IDELETE .EQ. 2) THEN
        IDELETE = 0
        IF (LINE(CURPOS) .EQ. CHAR(#20)) THEN
          CALL WRITFILE(CURPOS,ENDPOS,BEGPOS,LINE,SKIPWRIT)
        ENDIF
      ENDIF
C*
      IF (IDELETE .EQ. 1) THEN
        IF (LINE(CURPOS) .EQ. CHAR(#20)) THEN
           CALL WRITFILE(CURPOS,ENDPOS,BEGPOS,LINE,SKIPWRIT)
          IDELETE = 0
        ELSE
          IDELETE = 2
        ENDIF
      ENDIF
      END
C*
C*     END OF SUBROUTINE DELSPACE
C*********************************************************************
C*
      SUBROUTINE ENDOFLI(LINE,BEGPOS,CURPOS,EOLN,SPACE,ENDPOS,SKIPWRIT)
C*
C*     THE SUBROUTINE CHECKDATA FINDS THE END OF EACH LINE AND
C*     SETS A BOOLEAN VARIABLE, EOLN, TO TRUE.  THEN FOR THE
C*     NEXT LINE(CURPOS) CHARACTER, THIS SUBROUTINE IS CALLED.
C*     IF IT IS A SPACE, THE DATA BEFORE THE SPACE IN THE ARRAY 
C*     IS WRITTEN TO THE FILE, THE SPACE IS NOT.  THE BOOLEAN
C*     VARIABLE SPACE IS SET TO TRUE BECAUSE IF THERE ARE MORE
C*     SPACES FOUND IN A SEQUENCE, WE DON'T NEED TO WRITE, ONLY 
C*     CHANGE BEGPOS (THE BEGINNING OF LINE VARIABLE). 
C*     IF IT'S THE MAXIMUM POSITION IN THE ARRAY, THE POSITION OF 
C*     BEGPOS CAN'T BE MOVED.  A BOOLEAN VARIABLE, SKIPWRIT, IS SET
C*     TRUE WHICH CAUSES THE WRITE STATEMENT IN THE MAIN PROGRAM TO BE
C*     SKIPPED.  IF ANY OTHER
C*     CHARACTER IS FOUND, EOLN IS FALSE.  THE LINE FEED (HEX 0A)
C*     MIGHT BE AFTER THE CARRIAGE RETURN. IF SO, EOLN IS STILL TRUE
C*     AND THIS SUBROUTINE WILL BE CALLED TO CHECK THE NEXT POSITION.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      LOGICAL EOLN,SPACE,SKIPWRIT
C*
      IF (LINE(CURPOS) .EQ. CHAR(#20)) THEN
        IF (.NOT. SPACE) THEN
          CALL WRITFILE(CURPOS,ENDPOS,BEGPOS,LINE,SKIPWRIT)
          SPACE = .TRUE.
        ELSE
C*         (COMMENT:  SPACE = TRUE MEANS THIS ISN'T THE FIRST SPACE 
C*               IN THE SEQUENCE.)
          CALL SKIPCP(CURPOS,ENDPOS,BEGPOS,SKIPWRIT)
        ENDIF
      ELSE
C*        (COMMENT:  LINE(CURPOS) IS NOT A SPACE (CHAR(#20))
C*          IF IT IS CHAR(#0A), RETURN TO THIS SUBROUTINE
C*          ONE MORE TIME, OTHERWISE, EOLN IS FALSE)
        IF (LINE(CURPOS) .NE. CHAR(#0A)) THEN
          EOLN = .FALSE.
          SPACE = .FALSE.
        ENDIF
      ENDIF
      END
C*
C*    END OF SUBROUTINE ENDOFLI
C*************************************************************
C*
      SUBROUTINE WRITFILE(CURPOS,ENDPOS,BEGPOS,LINE,SKIPWRIT)
C*
C*     THIS SUBROUTINE WRITES DATA TO THE FILE AND SKIPS THE 
C*      CURRENT CHARACTER.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      LOGICAL SKIPWRIT
C*
          IF (CURPOS .NE. BEGPOS)
     :      WRITE(22)(LINE(I), I = BEGPOS, CURPOS-1)
            CALL SKIPCP(CURPOS,ENDPOS,BEGPOS,SKIPWRIT)
      END
C*    END OF SUBROUTINE WRITFILE
C*
C*******************************************************************
C*
      SUBROUTINE SKIPCP(CURPOS,ENDPOS,BEGPOS,SKIPWRIT)
C*
C*     THIS SUBROUTINE CAUSES THE CURRENT CHARACTER TO NOT BE SAVED
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      LOGICAL SKIPWRIT
C*
          IF (CURPOS .LT.ENDPOS) THEN
            BEGPOS = CURPOS+1
          ELSE
            SKIPWRIT = .TRUE.
          ENDIF
      END
C*    END OF SUBROUTINE SKIPCP
C*
C*********************************************************************
      SUBROUTINE CVTDEGRE(LINE, CURPOS, BEGPOS, SKIPWRIT,ENDPOS,DEG)
C*
C*    THIS SUBROUTINE IS DEGREE CONVERSION.  HEX 60, THE GRAVE 
C*    ACCENT, WAS A DEGREE CHARACTER IN THE LEXITRON FILE.  HERE
C*    IT IS REPLACED BY:  TOGGLE SUPERSCRIPT, LOWERCASE 'O', 
C*    TOGGLE SUPERSCRIPT.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      LOGICAL SKIPWRIT,DEG
C*
      DEG = .TRUE.
      LINE(CURPOS) = CHAR(#7F)
      WRITE(22)(LINE(I), I= BEGPOS,CURPOS)
      WRITE(22)CHAR(#09)
      WRITE(22)CHAR(#7F)
      WRITE(22)CHAR(#6F)
      WRITE(22)CHAR(#7F)
      WRITE(22)CHAR(#09)
      WRITE(22)CHAR(#7F)
      CALL SKIPCP(CURPOS,ENDPOS,BEGPOS,SKIPWRIT)
C*
      END
C*
C*    END OF SUBROUTING CVTDEGRE
C******************************************************************
C*
      SUBROUTINE UNDSCORE(LINE,TOGGLEON,BEGPOS,CURPOS,ENDPOS,SUBSPACE,
     :  NEXT,SKIPWRIT,KEND,KOUNT,UNSCR,LIMIT,IFILE)
C*
C*    THIS SUBROUTINE PUTS AN UNDERSCORE TOGGLE-ON CHARACTER
C*    IN THE FILE AND REMOVES UNDERSCORES.
C*
      INTEGER*4 KEND,KOUNT
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 NEXT(*)
      CHARACTER*1 LINE(*)
      LOGICAL UNSCR, TOGGLEON, SUBSPACE, SKIPWRIT
C*
      UNSCR = .TRUE.
C*
C*     IF IT IS NOT FIRST UNDERSCORE, ELIMINATE IT. IF TWO IN
C*      A SEQUENCE, REPLACE WITH A SPACE.
C*
      IF (LINE(CURPOS) .EQ. CHAR(#5F) .AND. TOGGLEON) THEN
        IF (.NOT. SUBSPACE) THEN
          IF (CURPOS. NE. BEGPOS)WRITE(24)(LINE(I), I=BEGPOS,CURPOS-1)
            IF (CURPOS .LT. ENDPOS) THEN
              BEGPOS = CURPOS + 1
            ELSE 
              SKIPWRIT = .TRUE.
            ENDIF
        ELSE
C*        (COMMENT:  SUBSPACE IS TRUE)
          LINE(CURPOS) = CHAR(#20)
          SUBSPACE = .FALSE.
        ENDIF
      ENDIF
C*
C*    CHECK FOR FIRST UNDERSCORE CHARACTER AND SET WS4 TOGGLE ON.
C*
      IF (.NOT. TOGGLEON) THEN
        LINE(CURPOS) = CHAR(#7F)
        WRITE(24)(LINE(I),I=BEGPOS,CURPOS)
        WRITE(24)CHAR(#06)
        WRITE(24)CHAR(#7F)
        IF (CURPOS .LT. ENDPOS) THEN
          BEGPOS = CURPOS+1
        ELSE
          SKIPWRIT = .TRUE.
        ENDIF
        TOGGLEON = .TRUE.
      ENDIF
C*
C*   CHECK FOR TWO HEX 5F IN SEQUENCE
C* 
      IF (LINE(CURPOS) .EQ. CHAR(#5F)) THEN
        IF (CURPOS .LE. LIMIT-1) THEN
          IF (LINE(CURPOS+1) .EQ. CHAR(#5F)) SUBSPACE = .TRUE.
        ELSEIF (KEND-KOUNT .GE. 1) THEN
C*        (COMMENT:  CURPOS IS LAST POSITION OF ARRAY)
         LAST = 1
          READ(IFILE) (NEXT(KK),KK=1,LAST)
          IF(NEXT(1).EQ.CHAR(#5F)) SUBSPACE = .TRUE.
          CALL BACKSP(KK,IFILE)
        ENDIF
      ENDIF
C*
C*
      END
C*
C*     END OF SUBROUTINE UNDSCORE
C*************************************************************
C*
      SUBROUTINE UNTOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE,
     :                  LIMIT,NEXT,KEND,KOUNT,IFILE)
C*
C*  THIS SUBROUTINE DETERMINES WHEN TO TOGGLE OFF THE UNDERSCORE.
C*
      INTEGER*4 KEND,KOUNT
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
      CHARACTER*1 POS1,POS2,POS5
      LOGICAL SKIPWRIT,TOGGLEON
C*
      IF (CURPOS .LE. LIMIT-5) THEN
        POS1 = LINE(CURPOS+1)
        POS2 = LINE(CURPOS+2)
        POS5 = LINE(CURPOS+5)
        CALL CHECKPOS(POS1,POS2,POS5,CURPOS,BEGPOS,ENDPOS,
     :              TOGGLEON,SKIPWRIT,LINE)
      ELSEIF (KEND-KOUNT .GE. 5) THEN
C*      (COMMENT:  CURPOS> LIMIT-5)
        READ(IFILE) (NEXT(KK), KK = 1,5)
       IF (CURPOS .EQ. LIMIT-4) THEN
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         POS5 = NEXT(1)
       ELSEIF (CURPOS .EQ. LIMIT-3) THEN
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         POS5 = NEXT(2)
       ELSEIF (CURPOS .EQ. LIMIT-2) THEN
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         POS5 = NEXT(3)
       ELSEIF (CURPOS .EQ. LIMIT-1) THEN
         POS1 = LINE(CURPOS+1)
         POS2 = NEXT(1)
         POS5 = NEXT(4)
       ELSEIF (CURPOS .EQ. LIMIT) THEN
         POS1 = NEXT(1)
         POS2 = NEXT(2)
         POS5 = NEXT(5)
       ELSE
         WRITE(*,'('' '',''ELSE IN UNTOFF FAILED TO MATCH'')')
       ENDIF
         CALL CHECKPOS(POS1,POS2,POS5,CURPOS,BEGPOS,ENDPOS,
     :        TOGGLEON,SKIPWRIT,LINE)
         CALL BACKSP(KK,IFILE)
      ELSE 
        CALL CHECKEND(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE,
     :          LIMIT,NEXT,KEND,KOUNT,IFILE)
      ENDIF
      END
C*
C*    END OF SUBROUTINE UNTOFF
C***************************************************************
C*
      SUBROUTINE CHECKEND(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE,
     :                  LIMIT,NEXT,KEND,KOUNT,IFILE)
C*
C*  IF THERE ARE LESS THAN 5 CHARACTERS LEFT IN THE FILE, 
C*  THIS SUBROUTINE DETERMINES WHEN TO TOGGLE OFF THE UNDERSCORE.
C*
      INTEGER*4 KEND,KOUNT
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
      CHARACTER*1 POS1,POS2,POS5
      LOGICAL SKIPWRIT,TOGGLEON
C*
      KK = 0
       IF (CURPOS .EQ. LIMIT-4) THEN
        IF (KEND-KOUNT .GE. 1)
     :    READ (IFILE) (NEXT(KK),KK= 1,1)
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         IF (KEND-KOUNT .LT. 1) THEN
          POS5 = ' '
C*          COMMENT: ASSIGN BLANK, NOT = HEX CHAR #5F
         ELSE
         POS5 = NEXT(1)
         ENDIF
       ELSEIF (CURPOS .EQ. LIMIT-3) THEN
        IF (KEND-KOUNT .GE. 2)
     :    READ(IFILE) (NEXT(KK), KK = 1,2)
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         IF (KEND-KOUNT .LT. 2) THEN
           POS5 = ' '
         ELSE
         POS5 = NEXT(2)
         ENDIF
       ELSEIF (CURPOS .EQ. LIMIT-2) THEN
        IF (KEND-KOUNT .GE. 3)
     :    READ (IFILE) (NEXT(KK), KK = 1,3)
         POS1 = LINE(CURPOS+1)
         POS2 = LINE(CURPOS+2)
         IF (KEND-KOUNT .LT. 3) THEN
           POS5 = ' '
         ELSE
         POS5 = NEXT(3)
         ENDIF
       ELSEIF (CURPOS .EQ. LIMIT-1) THEN
         IF (KEND-KOUNT .GE. 4) THEN
           READ (IFILE) (NEXT(KK), KK = 1,4)
         ELSEIF (KEND-KOUNT .LT. 4 .AND. KEND-KOUNT .GE. 1) THEN
           READ(IFILE)(NEXT(KK), KK= 1,1)
         ENDIF
         POS1 = LINE(CURPOS+1)
         IF (KEND-KOUNT .LT. 1) THEN 
           POS2 = ' '
         ELSE
         POS2 = NEXT(1)
         ENDIF
         IF (KEND-KOUNT .LT. 4) THEN
           POS5 = ' '
         ELSE
         POS5 = NEXT(4)
         ENDIF
       ELSEIF (CURPOS .EQ. LIMIT) THEN
         IF (KEND-KOUNT .GE. 2) THEN
           READ (IFILE) (NEXT(KK), KK = 1,2)
         ELSEIF (KEND-KOUNT .EQ. 1) THEN
           READ (IFILE) (NEXT(KK), KK = 1,1)
         ENDIF
         IF (KEND-KOUNT .LT. 1) THEN
           POS1 = ' '
         ELSE
         POS1 = NEXT(1)
         ENDIF
         IF (KEND-KOUNT .LT. 2) THEN
           POS2 = ' '
         ELSE
         POS2 = NEXT(2)
         ENDIF
         POS5 = ' '
       ELSE
         WRITE(*,'('' '',''ELSE IN CHECKEND FAILED TO MATCH'')')
       ENDIF
         CALL CHECKPOS(POS1,POS2,POS5,CURPOS,BEGPOS,ENDPOS,
     :        TOGGLEON,SKIPWRIT,LINE)
         IF (KK .NE. 0) CALL BACKSP(KK,IFILE)
      END
C*
C*    END OF SUBROUTINE CHECKEND
C***************************************************************
C*
      SUBROUTINE CHECKPOS(POS1,POS2,POS5,CURPOS,BEGPOS,ENDPOS,
     :                    TOGGLEON,SKIPWRIT, LINE)
C*
C*    THIS SUBROUTINE CHECKS POSITIONS FOR UNTOFF.  IF IT'S THE
C*    END OF LINE, END OF PARAGRAPH, OR SPACE, THEN CHARACTERS
C*    AHEAD ARE CHECKED.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER*1 LINE(*)
      CHARACTER*1 POS1,POS2,POS5
      LOGICAL TOGGLEON,SKIPWRIT
C*
        IF (POS1 .NE. CHAR(#5F) .AND. 
     :      POS1 .NE. CHAR(#20) .AND.
     :      POS1 .NE. CHAR(#0D) ) THEN
             CALL TOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE)
          ELSEIF (POS1 .EQ. CHAR (#20)) THEN
            IF  (POS2 .EQ. CHAR(#7F)) THEN
               IF (POS5 .NE. CHAR(#5F)) THEN
               CALL TOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE)
               ENDIF
            ELSEIF (POS2 .NE. CHAR(#5F)) THEN
               CALL TOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE)
            ENDIF
          ELSEIF (POS1 .EQ. CHAR(#0D) .AND.
     :        POS5 .NE. CHAR(#5F)) THEN
               CALL TOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE)
        ENDIF

      END
C*
C*     END OF SUBROUTINE CHECKPOS
C*****************************************************************
C*
      SUBROUTINE TOFF(CURPOS,BEGPOS,ENDPOS,TOGGLEON,SKIPWRIT,LINE)
C*
C*   THIS SUBROUTINE PUTS IN THE UNDERSCORE TOGGLE CHARACTERS.
C*
      INTEGER CURPOS,BEGPOS,ENDPOS
      CHARACTER *1 LINE(*)
      LOGICAL TOGGLEON,SKIPWRIT
C*
              WRITE(24) (LINE(I),I=BEGPOS,CURPOS)
              WRITE(24)CHAR(#7F)
              WRITE(24)CHAR(#06)
              WRITE(24)CHAR(#7F)
              TOGGLEON = .FALSE.
              IF (CURPOS .LT. ENDPOS) THEN
                BEGPOS = CURPOS+1
              ELSE
                SKIPWRIT = .TRUE.
              ENDIF
      END
C*
C**    END OF SUBROUTINE TOFF
C****************************************************************
C*
      SUBROUTINE SERSCK(LINE,SERIES,KEND,KOUNT,IFILE,NEXT,
     :      CURPOS,LIMIT)
C*
C*    THIS SUBROUTINE CHECKS FOR A SERIES OF UNDERSCORES AND
C*    ASSIGNS THE LOGICAL VARIABLE 'SERIES' TRUE IF THERE
C*    ARE THREE CONSECUTIVE UNDERSCORES.
C*
      CHARACTER*1 LINE(*)
      CHARACTER*1 NEXT(*)
      LOGICAL SERIES
      INTEGER*4 KOUNT,KEND
      INTEGER CURPOS
C*
      IF (CURPOS .LE. LIMIT-2) THEN
        IF (LINE(CURPOS+1) .EQ. CHAR(#5F)) THEN
          IF (LINE(CURPOS+2) .EQ. CHAR(#5F)) SERIES = .TRUE.
        ENDIF
      ELSEIF (KEND-KOUNT .GE. 2) THEN
        READ(IFILE) (NEXT(KK),KK=1,2)
        IF (CURPOS .EQ. LIMIT-1) THEN
          IF (LINE(CURPOS+1) .EQ. CHAR(#5F)) THEN
            IF (NEXT(1) .EQ. CHAR(#5F)) SERIES = .TRUE.
          ENDIF
        ELSEIF (CURPOS .EQ. LIMIT) THEN
          IF (NEXT(1) .EQ. CHAR(#5F)) THEN
            IF (NEXT(2) .EQ. CHAR(#5F)) SERIES = .TRUE.
          ENDIF
        ENDIF
        CALL BACKSP(KK,IFILE)
      ENDIF
C*
      END
C*    END OF SUBROUTINE SERSCK
C********************************************************************
